//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Gold
#property indicator_color2 Aqua
#property indicator_width1 2
#property indicator_width2 2

//
//
//
//
//

extern int    Risk            = 4;
extern double ArrowsGap       = 1.0;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

double arrDn[];
double arrUp[];
double wpr[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,arrDn); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,159);
   SetIndexBuffer(1,arrUp); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);
   SetIndexBuffer(2,wpr);
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   double x1 = 67.0+Risk;
   double x2 = 33.0-Risk;
   for (int i=limit; i>=0 ; i--)
   {
      int    period = 3+Risk*2;
      double range  = 0; for (int k=0; k<10; k++) range += High[i+k]-Low[i+k]; range /= 10.0;
      bool   found1 = false; for (k=0; k<6 && !found1; k++) found1 = (MathAbs(Open[i+k] -Close[i+k+1])>=range*2.0);
      bool   found2 = false; for (k=0; k<9 && !found2; k++) found2 = (MathAbs(Close[i+k+3]-Close[i+k])>=range*4.6);
             if (found1) period = 3;
             if (found2) period = 4;
                  wpr[i]   = 100+iWPR(NULL,0,period,i);

      //
      //
      //
      //
      //
               
      arrDn[i] = EMPTY_VALUE;
      arrUp[i] = EMPTY_VALUE;
         if (wpr[i] < x2) { for (k=1; i+k<Bars && wpr[i+k]>=x2 && wpr[i+k]<=x1;) k++; if (wpr[i+k]>x1) arrDn[i] = High[i]+range*ArrowsGap; }
         if (wpr[i] > x1) { for (k=1; i+k<Bars && wpr[i+k]>=x2 && wpr[i+k]<=x1;) k++; if (wpr[i+k]<x2) arrUp[i] = Low[i] -range*ArrowsGap; }
   }
   manageAlerts();
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (arrDn[whichBar] != EMPTY_VALUE || arrUp[whichBar] != EMPTY_VALUE)
      {
         if (arrUp[whichBar] != EMPTY_VALUE) doAlert(whichBar,"up");
         if (arrDn[whichBar] != EMPTY_VALUE) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Trend Signal trend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Trend Signal"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

